import {
    createDefaultModule, createDefaultSharedModule, DefaultSharedModuleContext, inject,
    LangiumServices, LangiumSharedServices, Module, PartialLangiumServices
} from 'langium';
import { CustomScopeComputation } from './guitar-scope';
import { GuitarGeneratedModule, GuitarGeneratedSharedModule } from './generated/module';
import { GuitarValidator, registerValidationChecks } from './guitar-validator';

/**
 * Declaration of custom services - add your own service classes here.
 */
export type GuitarAddedServices = {
    
    validation: {
        GuitarValidator: GuitarValidator
    }
}

/**
 * Union of Langium default services and your custom services - use this as constructor parameter
 * of custom service classes.
 */
export type GuitarServices = LangiumServices & GuitarAddedServices

/**
 * Dependency injection module that overrides Langium default services and contributes the
 * declared custom services. The Langium defaults can be partially specified to override only
 * selected services, while the custom services must be fully specified.
 */
export const GuitarModule: Module<GuitarServices, PartialLangiumServices & GuitarAddedServices> = {
    references:{
        ScopeComputation: (services) => new CustomScopeComputation(services)
    }, 
    validation: {
        GuitarValidator: () => new GuitarValidator()
    }
};

/**
 * Create the full set of services required by Langium.
 *
 * First inject the shared services by merging two modules:
 *  - Langium default shared services
 *  - Services generated by langium-cli
 *
 * Then inject the language-specific services by merging three modules:
 *  - Langium default language-specific services
 *  - Services generated by langium-cli
 *  - Services specified in this file
 *
 * @param context Optional module context with the LSP connection
 * @returns An object wrapping the shared services and the language-specific services
 */
export function createGuitarServices(context: DefaultSharedModuleContext): {
    shared: LangiumSharedServices,
    Guitar: GuitarServices
} {
    const shared = inject(
        createDefaultSharedModule(context),
        GuitarGeneratedSharedModule
    );
    const Guitar = inject(
        createDefaultModule({ shared }),
        GuitarGeneratedModule,
        GuitarModule
    );
    shared.ServiceRegistry.register(Guitar);
    registerValidationChecks(Guitar);
    return { shared, Guitar };
}
